SystemOrganization addCategory: #'Add-Ons-HTML0'!

Canvas subclass: #MorphicHTMLCanvas0
	instanceVariableNames: 'topLevelMorph morphLevel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Add-Ons-HTML0'!

!MorphicHTMLCanvas0 commentStamp: 'hjh 10/2/2017 13:02' prior: 0!
A MorphicHTMLCanvas0 serves as a demonstration canvas how a morph (with the hierarchy of submorphs) may be rendered as HTML.


!

!MorphicHTMLCanvas0 class methodsFor: 'as yet unclassified' stamp: 'hjh 10/2/2017 12:24'!
defaultTarget
	^HTMLCSSEncoder0 stream! !

!MorphicHTMLCanvas0 class methodsFor: 'as yet unclassified' stamp: 'hjh 10/2/2017 12:17'!
morphAsHTML: aMorph

" implemented after the example of
morphAsPostscript:aMorph rotated:rotateFlag offsetBy:offset
"
 | htmlCanvas |
  htmlCanvas := self new.
  htmlCanvas reset.
 " htmlCanvas bounds: (0@0 extent: (aMorph bounds extent + (2 * offset)))."
"  htmlCanvas topLevelMorph:aMorph."
  "htmlCanvas resetContentRotated: rotateFlag."
  htmlCanvas fullDrawMorph: aMorph .
  ^htmlCanvas contents.! !

!MorphicHTMLCanvas0 methodsFor: 'as yet unclassified' stamp: 'hjh 10/2/2017 12:19'!
fullDraw: aMorph 

"code below follows the structure  from PostscriptCanvas fullDraw: aMorph "

"	self comment: 'start morph: ' with: aMorph."

"	self comment: 'level: ' with: morphLevel.
	self comment: 'bounds: ' with: aMorph bounds.
	self comment: 'corner: ' with: aMorph bounds corner."
"	morphLevel := morphLevel + 1."
"	self setupGStateForMorph: aMorph."
	
	aMorph fullDrawHTMLOn: self.

"	self endGStateForMorph: aMorph."
"	morphLevel := morphLevel - 1."
"	self comment: 'end morph: ' with: aMorph."
"	self comment: 'level: ' with: morphLevel."
! !

!Morph methodsFor: '*Add-Ons-HTML0' stamp: 'hjh 10/2/2017 12:04'!
fullDrawHTMLOn: aCanvas

self halt.

"Here I can access 

    aCanvas target 

and directly generate HTML and CSS code

eg. ask for a
    <div id='...'>.... </div>

and put the morph properties into CSS rules.

"


"compare with"
"fullDrawPostscriptOn: aCanvas"
"	self fullDrawOn:aCanvas."! !

!Object methodsFor: '*Add-Ons-HTML0' stamp: 'hjh 10/2/2017 11:56'!
fullDrawHTMLOn: aStream

"do not do anything yet" 


"for an example see

fullDrawPostscriptOn: aStream
    	^aStream fullDraw:self.
"! !

TestCase subclass: #MorphicHTMLCanvas0Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Add-Ons-HTML0'!

!MorphicHTMLCanvas0Test methodsFor: 'as yet unclassified' stamp: 'hjh 10/2/2017 12:15'!
createTestMorph
	"MorphicHTMLCanvas0Test new createTestMorph openInWorld"
	| slide |
	slide := RectangleMorph new extent: 800 @ 600;
				 position: 10 @ 50;
				 color: Color blue.
	slide addMorph: (RectangleMorph new extent: 100 @ 100;
			 position: 20 @ 60;
			 color: Color yellow).
	^ slide! !

!MorphicHTMLCanvas0Test methodsFor: 'as yet unclassified' stamp: 'hjh 10/2/2017 11:47'!
test01

self assert: (MorphicHTMLCanvas0 morphAsHTML: self createTestMorph)! !

PrintableEncoder subclass: #HTMLCSSEncoder0
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Add-Ons-HTML0'!

!HTMLCSSEncoder0 commentStamp: 'hjh 10/2/2017 13:03' prior: 0!
A HTMLCSSEncoder0 is the HTML/CSS rendering object which goes with MorphicHTMLCanvas0

!
